﻿init python:
    from copy import deepcopy
    def get_key():
        if event in pygame.event.get():
            if event.type == pygame.KEYDOWN:
                msg.msg("key down")
            if event.type == pygame.KEYUP:
                msg.msg("key up")
    def load_map(tilemap):
        map = []
        f = open(renpy.loader.transfn(tilemap),"r")
        for line in f:
            line = line.strip()
            divided = line.split(",")
            listed = [[x, []] for x in divided]
            map.append(listed)
        f.close()
        return map
    def load_tiles(img, size):
        tiles = []
        for i in range(8):
            for ii in range(8):
                tiles.append(Crop((ii*size,i*size,size,size), img))
        return tiles

    class tile:
        def __init__(self, image, type):
            self.image = image
            self.type = type

    class level_class:
        def __init__(self, name, size, map, objects, player, entrances, exits, npc = []):
            self.name = name
            self.size = size
            self.set = load_tiles(map[0], size)
            self.map = load_map(map[1])
            self.player = player
            self.entrances = entrances
            self.exits = exits
            self.npc = []
            for i in npc:
                i[0].x , i[0].y = i[1], i[2]
                self.npc.append(i[0])
            self.collisions = []
            for i in range(-1, 24):
                self.collisions.append(str(i))
            if objects:
                for i in objects:
                    self.map[i[1]][i[0]][1].append(i[2])
            self.enemies = []

        def can_move(self, x, y):
            for i in self.enemies:
                if i.y == y:
                    if i.x == x:
                        return False
            for i in self.npc:
                if i.y == y:
                    if i.x == x:
                        return False
            if self.player.y == y:
                if self.player.x == x:
                    return False
            if self.map[y][x][0] in self.collisions:
                return False
            else:
                return True
        def spawn(self, enemy):
            while True:
                x = renpy.random.randint(0, 27)
                y = renpy.random.randint(0, 11)
                if self.can_move(x, y):
                    break
            enemy = deepcopy(enemy)
            enemy.x = x
            enemy.y = y
            self.enemies.append(enemy)
        def take(self):
            if len(self.map[player.y][player.x][1]):
                it = self.map[player.y][player.x][1].pop()
                if isinstance(it, item):
                    self.player.got(stack(it, 1))
                else:
                    self.player.got(it)

        def enter(self, entrance):
            self.player.x = self.entrances[entrance][0]
            self.player.y = self.entrances[entrance][1]
        def show_player(self):
            self.player.alpha = 1
        def move(self, direction):
            self.player.direction = direction
            self.player.busy = 10
            self.player.locked = True
            self.player.stat = "walk"
            x = self.player.x
            y = self.player.y
            if direction == "up":
                if self.can_move(x, y - 1):
                    self.player.y -= 1
                else:
                    self.action(x, y - 1)
            elif direction == "left":
                if self.can_move(x -1, y):
                    self.player.x -= 1
                else:
                    self.action(x -1, y)
            elif direction == "down":
                if self.can_move(x, y + 1):
                    self.player.y += 1
                else:
                    self.action(x, y + 1)
            elif direction == "right":
                if self.can_move(x + 1, y):
                    self.player.x += 1
                else:
                    self.action(x + 1, y)

            x = self.player.x
            y = self.player.y
            for i in self.exits:
                if i[0] == x and i[1] == y:
                    g = eval(i[2])
                    self.player.alpha = 0
                    self.player.x, self.player.y = g.entrances[i[3]]
                    Show("level", g = g, transition = dissolve)()
            else:
                
                self.enemies_turn()
        def walk(self, person, direction):
            person.direction = direction
            person.busy = 10
            person.locked = True
            person.stat = "walk"
            if direction == "up":
                if self.can_move(person.x, person.y-1):
                    person.y -= 1
            elif direction == "left":
                if self.can_move(person.x-1, person.y):
                    person.x -= 1
            elif direction == "down":
                if self.can_move(person.x, person.y+1):
                    person.y += 1
            elif direction == "right":
                if self.can_move(person.x+1, person.y):
                    person.x += 1



        def action(self, x, y):
            for i in self.enemies:
                if i.y == y:
                    if i.x == x:
                        msg.msg("there's an enemy there")
            for i in self.npc:
                if i.y == y:
                    if i.x == x:
                        i.face(self.player)
                        Call(i.name.lower())()

        def enemies_turn(self):
            for i in self.enemies:
                self.walk(i, renpy.random.choice(["up", "left", "down", "right"]))
screen level(g):
    default scale = 2.0
    if not g.player.alpha:
        timer .4 action Function(g.show_player)
    hbox:
        align .5,.0 spacing 10
        bar value ScreenVariableValue("scale", 3.0, offset=1.0) xysize 500,40
        button:
            ysize 40 xpadding 10
            text "reset" align .5,.5
            action SetScreenVariable("scale", 2.0)
    fixed:
        fit_first True align(.5, .0) yoffset 64
        at zoom(scale)
        frame:
            background None padding(0,0)
            vbox:
                spacing 0
                for ii in g.map:
                    hbox:
                        spacing 0
                        for i in ii:
                            if i[0] == "-1":
                                frame:
                                    background None xysize(g.size,g.size)
                            else:
                                frame:
                                    background g.set[int(i[0])]
                                    xysize(g.size,g.size)
                                    if len(i[1]):
                                        add i[1][0].icon align .5,.5 at zoom(.5)
                                # add i.image
        for i in g.npc:
            frame:
                xysize(g.size, g.size) background None at player_move(i.x*g.size, i.y*g.size) align .0,.0
                add "{} {} {}".format(i.name, i.direction, i.stat) align(.5,.5) yoffset -8 #at alpha(g.player.alpha)
        for i in g.enemies:
            frame:
                xysize(g.size, g.size) background None at player_move(i.x*g.size, i.y*g.size) align .0,.0
                add "{} {} {}".format(i.name, i.direction, i.stat) align(.5,.5) yoffset -8 #at alpha(g.player.alpha)

        frame:
            xysize(g.size, g.size) background None at player_move(g.player.x*g.size, g.player.y*g.size) align .0,.0
            add "{} {} {}".format(g.player.name, g.player.direction, g.player.stat) align(.5,.5) yoffset -8 at alpha(g.player.alpha)


    if g.player.busy > 0:
        timer .06 repeat True action Function(g.player.tick)
    if g.player.locked:
        timer .32 repeat True action Function(g.player.unlock)
        key "w" action NullAction()
        key "a" action NullAction()
        key "s" action NullAction()
        key "d" action NullAction()
    else:
        key "w" action Function(g.move, "up")
        key "a" action Function(g.move, "left")
        key "s" action Function(g.move, "down")
        key "d" action Function(g.move, "right")
        key "repeat_w" action Function(g.move, "up")
        key "repeat_a" action Function(g.move, "left")
        key "repeat_s" action Function(g.move, "down")
        key "repeat_d" action Function(g.move, "right")
    key "e" action Function(g.take)
    vbox:
        align .0,.0
        text "{}   {},{}".format(g.name, g.player.x, g.player.y)
        text "{},{}".format(thora.x - player.x, thora.y - player.y)
    drag:
        align .99,.4
        frame:
            vbox:
                spacing 10
                text "Tests"
                button:
                    text "Spawn"
                    action Function(g.spawn, demon)
                button:
                    text "Face"
                    action Function(thora.face, hero)
                button:
                    text "Face way"
                    action Function(thora.face, hero, True)
transform player_move(x, y):
    linear .45 xpos x ypos y

